t = 0.1
yI = 0           # initial position at top of screen
xI = 400         # initial position in middle of screen
vYI = 0         # initial vertical velocity
yF = 0           # final position (to be calculated)  
xF = 0           # final position (to be calculated)
vYF = 0          # final velocity after time t passes
aY = 9.8         # vertical acceleration (except when rockets fire)
vAVG = 0         # average vertical velocity 
ball_size = 20
paddle_size = 100

def draw_paddle():
    fill(255)
    paddle_height = 20
    rect(mouseX - paddle_size / 2, height - 20, paddle_size, paddle_height)
    fill(128)

def draw_ball(x, y):
    fill(0)
    ellipse(x-ball_size/2, y-ball_size/2, ball_size, ball_size)
    fill(128)
        
def setup():
    size(800, 600)
    
def draw():
    global t, xI, yI, xF, yF, vYI, vYF, aY, vAVG, paddle_size
    background(128)
    draw_paddle()
    # calculate new positions
    xF = xI
    vYF = vYI + aY * t           # kinematics!
    vYAVG = (vYI + vYF) / 2.0    # used to get new position
    yF = (yI + vYAVG * t)        # calculate new position            
    
    # check if ball hit paddle
    if yF >= height - 20:
        if xF + ball_size / 2 > mouseX - paddle_size / 2 and xF + ball_size / 2 < mouseX + paddle_size / 2:
            yF = yI    # back to original position?
            vYF = vYI * -1           # turn the ball around

    if yF >= height + 20:
        textSize(24)
        textAlign(CENTER)
        fill(255)
        text("Game over!", width / 2, height - 20)
        noLoop()
            
            
    yI = yF
    vYI = vYF
    xI = xF
    
    # draw ball
    draw_ball(xF, yF)
       